Chayse.Variable.TimelessChestsArray = {
	{
		"TimelessIsle",
		{
			{33170,"One-Time Chest 000",36.67,34.08},
			{33171,"One-Time Chest 001",25.49,27.19},
			{33172,"One-Time Chest 002",27.39,39.14},
			{33173,"One-Time Chest 003",30.66,36.48},
			{33174,"One-Time Chest 004",22.39,35.35},
			{33175,"One-Time Chest 005",22.14,49.27},
			{33176,"One-Time Chest 006",24.80,53.05},
			{33177,"One-Time Chest 007",25.70,45.85},
			{33178,"One-Time Chest 008",22.26,68.09},
			{33179,"One-Time Chest 009",26.85,68.74},
			{33180,"One-Time Chest 010",31.02,76.36},
			{33181,"One-Time Chest 011",35.34,76.44},
			{33182,"One-Time Chest 012",38.75,71.62},
			{33183,"One-Time Chest 013",39.81,79.51},
			{33184,"One-Time Chest 014",34.83,84.21},
			{33185,"One-Time Chest 015",43.54,84.14},
			{33186,"One-Time Chest 016",47.0,53.7},
			{33187,"One-Time Chest 017",46.71,46.75},
			{33188,"One-Time Chest 018",51.16,45.69},
			{33189,"One-Time Chest 019",55.54,44.33},
			{33190,"One-Time Chest 020",58.02,50.69},
			{33191,"One-Time Chest 021",65.61,47.87},
			{33192,"One-Time Chest 022",63.80,59.15},
			{33193,"One-Time Chest 023",64.88,75.59},
			{33194,"One-Time Chest 024",60.20,66.06},
			{33195,"One-Time Chest 025",49.72,65.73},
			{33196,"One-Time Chest 026",53.10,70.82},
			{33197,"One-Time Chest 027",52.7,62.7},
			{33227,"One-Time Chest 028",61.67,88.53},
			{33198,"One-Time Chest - Stump Center",44.13,65.43},
			{33199,"One-Time Chest - Stump SW Shore",26.02,61.43},
			{33200,"One-Time Chest - Stump West",24.63,38.63},
			{33202,"One-Time Chest - Steam Shore",29.77,31.72},
			{33201,"One-Time Chest - Ordo Lake Lower",59.93,31.34},
			{33203,"One-Time Chest - Cavern of Lost Spirits",49.7,32.3},
			{33204,"One-Time Chest - Carry Bird 1",28.16,35.12},
			{33205,"One-Time Chest - Carry Bird 2",26.69,64.97},
			{33206,"One-Time Chest - Gulp Frogs",64.65,70.49},
			{33207,"One-Time Chest - Hammer Cavern",59.25,49.47},
			{33208,"One-Time Chest - Ordo Chest 000",69.47,33.10},
			{33209,"One-Time Chest - Ordo Chest 001",54.04,78.17},
			{33210,"One-Time Chest - Blazing Chest",47.27,26.86}
			},
		"Timeless Isle"
	}
}

function Chayse.Function.DetermineLocalNeededTimelessChests()
	local location = GetMapInfo()
	for x=1,#Chayse.Variable.TimelessChestsArray do
		if location==Chayse.Variable.TimelessChestsArray[x][1] then
			for y=1,#Chayse.Variable.TimelessChestsArray[x][2] do
				if
					IsQuestFlaggedCompleted(Chayse.Variable.TimelessChestsArray[x][2][y][1])==1
				then
				else
					print(Chayse.Variable.TimelessChestsArray[x][2][y][2].." "..Chayse.Variable.TimelessChestsArray[x][2][y][3]..","..Chayse.Variable.TimelessChestsArray[x][2][y][4])
				end
			end
		end
	end
end

function Chayse.Function.DetermineGlobalNeededTimelessChests()
	for x=1,#Chayse.Variable.TimelessChestsArray do
		for y=1,#Chayse.Variable.TimelessChestsArray[x][2] do
			if
				IsQuestFlaggedCompleted(Chayse.Variable.TimelessChestsArray[x][2][y][1])==1
			then
			else
				print(Chayse.Variable.TimelessChestsArray[x][1].." \'"..Chayse.Variable.TimelessChestsArray[x][2][y][2].."\' "..Chayse.Variable.TimelessChestsArray[x][2][y][3]..","..Chayse.Variable.TimelessChestsArray[x][2][y][4])
			end
		end
	end
end

function Chayse.Function.SetTimelessChestWaypointArray()
	Chayse.Variable.TimelessChestWaypointArray = {}
	for x=1,#Chayse.Variable.TimelessChestsArray do
		for y=1,#Chayse.Variable.TimelessChestsArray[x][2] do
			if
				IsQuestFlaggedCompleted(Chayse.Variable.TimelessChestsArray[x][2][y][1])==1
			then
			else
				table.insert(Chayse.Variable.TimelessChestWaypointArray,"/way "..Chayse.Variable.TimelessChestsArray[x][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][4].." "..Chayse.Variable.TimelessChestsArray[x][2][y][2])
			end
		end
	end
	table.insert(Chayse.Variable.TimelessChestWaypointArray,"/cway")
	table.insert(Chayse.Variable.TimelessChestWaypointArray,"/run Chayse.Frame.TimelessChestsButton:Hide()")
	Chayse.FrameText.TimelessChestsButton:SetText("FIND CHESTS")
	Chayse.Function.ShowTimelessChestsButton(Chayse.Variable.TimelessChestWaypointArray[1])
end

function Chayse.Function.SetAllTimelessChestWaypointArray()
	Chayse.Variable.TimelessChestWaypointArray = {}
	for x=1,#Chayse.Variable.TimelessChestsArray do
		for y=1,#Chayse.Variable.TimelessChestsArray[x][2] do
			table.insert(Chayse.Variable.TimelessChestWaypointArray,"/way "..Chayse.Variable.TimelessChestsArray[x][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][4].." "..Chayse.Variable.TimelessChestsArray[x][2][y][2])
		end
	end
	table.insert(Chayse.Variable.TimelessChestWaypointArray,"/cway")
	table.insert(Chayse.Variable.TimelessChestWaypointArray,"/run Chayse.Frame.TimelessChestsButton:Hide()")
	Chayse.FrameText.TimelessChestsButton:SetText("FIND CHESTS")
	Chayse.Function.ShowTimelessChestsButton(Chayse.Variable.TimelessChestWaypointArray[1])
end

function Chayse.Function.SetAltTimelessChestWaypointArray()
	print('alt')
	Chayse.Variable.TimelessChestWaypointArray = {}
	for x=1,#Chayse.Variable.TimelessChestsArray do
		for y=1,#Chayse.Variable.TimelessChestsArray[x][2] do
			if
				IsQuestFlaggedCompleted(Chayse.Variable.TimelessChestsArray[x][2][y][1])==1
			then
			else
				table.insert(Chayse.Variable.TimelessChestWaypointArray,"/way "..Chayse.Variable.TimelessChestsArray[x][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][3].." "..Chayse.Variable.TimelessChestsArray[x][2][y][4].." "..Chayse.Variable.TimelessChestsArray[x][2][y][2])
			end
		end
	end
	table.insert(Chayse.Variable.TimelessChestWaypointArray,"/cway\n/run Chayse.Frame.TimelessChestsButton:Hide()")
	Chayse.FrameText.TimelessChestsButton:SetText("FIND ALT CHESTS")
	Chayse.Function.ShowAltTimelessChestsButton(Chayse.Variable.TimelessChestWaypointArray[1])
end

function Chayse.Function.ShowTimelessChestsButton(arg1)
	Chayse.Frame.TimelessChestsButton:SetAttribute( "type", "macro" )
	Chayse.Frame.TimelessChestsButton:RegisterForClicks("AnyUp")
	if
		#Chayse.Variable.TimelessChestWaypointArray>1
	then
		Chayse.Frame.TimelessChestsButton:SetAttribute( "macrotext", arg1.."\n/run table.remove(Chayse.Variable.TimelessChestWaypointArray,1) Chayse.Function.ShowTimelessChestsButton(Chayse.Variable.TimelessChestWaypointArray[1])"  )
	else
		Chayse.Frame.TimelessChestsButton:SetAttribute( "macrotext", arg1.."\n/run table.remove(Chayse.Variable.TimelessChestWaypointArray,1)"  )
	end
	Chayse.Frame.TimelessChestsButton:Show()
end

function Chayse.Function.ShowAltTimelessChestsButton(arg1)
	print('/run print("running") Chayse.TexturedFrame.CustomCode:SetText("'..string.gsub(arg1,'\\\\','\\')..'")')
	Chayse.Frame.TimelessChestsButton:SetAttribute( "type", "macro" )
	Chayse.Frame.TimelessChestsButton:RegisterForClicks("AnyUp")
	Chayse.Frame.TimelessChestsButton:SetAttribute( "macrotext", '/run Chayse.TexturedFrame.CustomCode:SetText("'..string.gsub(arg1,'\\\\','\\')..'") Chayse.Function.CustomCodeSecure() Chayse.Function.ShowAltTimelessChestsButton(Chayse.Variable.TimelessChestWaypointArray[1]) table.remove(Chayse.Variable.TimelessChestWaypointArray,1) if #Chayse.Variable.TimelessChestWaypointArray==nil then Chayse.Frame.TimelessChestsButton:Hide() end' )
	Chayse.Frame.TimelessChestsButton:Show()
end

Chayse.Function.CreateFrame("Button","TimelessChestsButton",UIParent,"SecureActionButtonTemplate",Chayse.Variable.DefaultBackdrop,Chayse.Variable.DefaultBackdropColor,75,75,"CENTER",UIParent,"CENTER",75,0,true)
Chayse.Function.CreateFrameText(Chayse.Frame.TimelessChestsButton,"TimelessChestsButton","GameFontHighlightLarge",65,Chayse.Variable.DefaultTextColor,"CENTER","CENTER")
Chayse.FrameText.TimelessChestsButton:SetText("FIND CHESTS")
Chayse.Frame.TimelessChestsButton:Hide()

Chayse.Function.CreateFrame("Button","TimelessChestsCloseButton",Chayse.Frame.TimelessChestsButton,nil,Chayse.Variable.DefaultBackdrop,{1,0,0},20,20,"BOTTOMLEFT",Chayse.Frame.TimelessChestsButton,"TOPRIGHT",0,0,true,nil,nil,nil,nil,nil,nil,function() Chayse.Frame.TimelessChestsButton:Hide() end)

SLASH_TIMELESS1 = "/cstt"
local function timelesshandler(msg, editbox)
	Chayse.Function.SetTimelessChestWaypointArray()
end
SlashCmdList["TIMELESS"] = timelesshandler
